module Syntax where
import Types
import Constants

data Prog = Prog   Block  
          deriving Show
data Block = Empty | DefsBlock DList Block | TrafoBlock Transform Block
           deriving Show
data DList = DList   Defs  
           deriving Show
data SourceFile = SourceFile Elems
         deriving Show
data Elems = NoElem | OneElem Elem Elems Int 
         deriving Show
data Elem = DefElem Def | TrafoElem Transform
         deriving Show
data Defs = NoDef | OneDef Def Defs Int
          deriving Show
data Def = Fun   Exp  Exp 
         | Dec   Exp  Type
         | Data   Type  Alts
         deriving Show
data Transform = Rewrite String [String] DList DList Theory
         deriving Show
data Alts = NoAlt | OneAlt   Alt  Alts  
          deriving Show
data Alt = Alt   String  TypeList  
         deriving Show
data Exp = Lam   Exp  Exp  Type
         | Let   DList  Exp  Type
         | Ap   Exp  Exp  Type
         | Var   String  Type
         | Con   Constant  Type
          
         deriving Show
data Theory = Theory   Theo  
            deriving Show
data Theo = NoTheo | CeqTheo   Ceq  Theo | DefnTheo String Theo
          deriving Show
data Ceq = Ceq   String  Eqs  Eqn  Int
         deriving Show
data Eqs = NoEq | OneEq   Eqn  Eqs  
         deriving Show
data Eqn = Eqn   Exp  Exp 
         deriving Show
